Index: c/src/exec/libcsupport/src/mount.c
===================================================================
--- c/src/exec/libcsupport/src/mount.c	(revision ee6d2050d1523110f09417e12cd1df8e2d4ad639)
+++ c/src/exec/libcsupport/src/mount.c	(revision 4b0d1ab39bad414e8d5ecfb46f66e75387152458)
@@ -36,9 +36,8 @@
  */
 
-int search_mt_for_mount_point(
-  rtems_filesystem_location_info_t *location_of_mount_point
+int init_fs_mount_table( void );
+static int Is_node_fs_root(
+  rtems_filesystem_location_info_t  *loc
 );
-
-int init_fs_mount_table( void );
 
 
@@ -141,5 +140,5 @@
      */
 
-    if ( search_mt_for_mount_point( &loc ) == FOUND ) {
+    if ( Is_node_fs_root(  &loc ) ){
       errno = EBUSY;
       goto cleanup_and_bail;
@@ -233,19 +232,17 @@
 }
 
-
-/*
- *  search_mt_for_mount_point
+/*
+ *  Is_node_fs_root
  *
  *  This routine will run through the entries that currently exist in the
  *  mount table chain. For each entry in the mount table chain it will
- *  compare the mount tables mt_point_node to the node describing the selected
- *  mount point.. If any of the mount table file system mount point nodes
- *  match the new file system selected mount point node, we are attempting
- *  to mount the new file system onto a node that already has a file system
- *  mounted to it. This is not a permitted operation.
- */
-
-int search_mt_for_mount_point(
-  rtems_filesystem_location_info_t *location_of_mount_point
+ *  compare the mount tables root node to the node describing the selected
+ *  mount point. If any match is found true is returned else false is 
+ *  returned.
+ *
+ */
+
+static int Is_node_fs_root(
+  rtems_filesystem_location_info_t  *loc
 )
 {
@@ -253,14 +250,15 @@
   rtems_filesystem_mount_table_entry_t *the_mount_entry;
 
+  /* 
+   * For each mount table entry 
+   */
+
   for ( the_node = rtems_filesystem_mount_table_control.first;
         !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
         the_node = the_node->next ) {
-
      the_mount_entry = (rtems_filesystem_mount_table_entry_t *) the_node;
-     if ( the_mount_entry->mt_point_node.node_access  == 
-             location_of_mount_point->node_access )
-        return FOUND;
-  }
-  return NOT_FOUND;
+     if ( the_mount_entry->mt_fs_root.node_access  == loc->node_access )
+        return TRUE;
+  }
+  return FALSE;
 }
-
Index: c/src/exec/libcsupport/src/unmount.c
===================================================================
--- c/src/exec/libcsupport/src/unmount.c	(revision ee6d2050d1523110f09417e12cd1df8e2d4ad639)
+++ c/src/exec/libcsupport/src/unmount.c	(revision 4b0d1ab39bad414e8d5ecfb46f66e75387152458)
@@ -42,5 +42,5 @@
 
 int file_systems_below_this_mountpoint( 
-  const char                            *mount_path,
+  const char                            *path,
   rtems_filesystem_location_info_t      *temp_loc,
   rtems_filesystem_mount_table_entry_t  *temp_mt_entry
@@ -51,23 +51,23 @@
  * 
  *  This routine will attempt to unmount the file system that has been
- *  is mounted a mount_path.  If the operation is successful, 0 will
+ *  is mounted a path.  If the operation is successful, 0 will
  *  be returned to the calling routine.  Otherwise, 1 will be returned.
  */
 
 int unmount(
-  const char *mount_path
+  const char *path
 )
 {
   int                                   status;
-  rtems_filesystem_location_info_t      temp_loc;
+  rtems_filesystem_location_info_t      fs_root_loc;
   rtems_filesystem_mount_table_entry_t  temp_mt_entry;
 
   /*
-   *  Are there any file systems below the mount_path specified
+   *  Are there any file systems below the path specified
    */
 
   status = file_systems_below_this_mountpoint( 
-    mount_path, 
-    &temp_loc,
+    path, 
+    &fs_root_loc,
     &temp_mt_entry
   );
@@ -81,6 +81,6 @@
    */
 
-  if ( rtems_filesystem_current.mt_entry == temp_loc.mt_entry ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ( rtems_filesystem_current.mt_entry == fs_root_loc.mt_entry ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     set_errno_and_return_minus_one( EBUSY );
   }
@@ -92,15 +92,15 @@
    */
 
-  if ( rtems_libio_is_open_files_in_fs( temp_loc.mt_entry ) == 1 ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ( rtems_libio_is_open_files_in_fs( fs_root_loc.mt_entry ) == 1 ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     set_errno_and_return_minus_one( EBUSY );
   }
   
   /*
-   * Allow the file system being mounted on to do its cleanup.
+   * Allow the file system being unmounted on to do its cleanup.
    */
 
-  if ((temp_mt_entry.mt_point_node.ops->unmount_h )( temp_loc.mt_entry ) != 0 ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ((temp_mt_entry.mt_point_node.ops->unmount_h )( fs_root_loc.mt_entry ) != 0 ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     return -1;
   }
@@ -110,6 +110,6 @@
    */
 
-  if ((temp_mt_entry.mt_fs_root.ops->fsunmount_me_h )( temp_loc.mt_entry ) != 0){
-    rtems_filesystem_freenode( &temp_loc );
+  if ((temp_mt_entry.mt_fs_root.ops->fsunmount_me_h )( fs_root_loc.mt_entry ) != 0){
+    rtems_filesystem_freenode( &fs_root_loc );
     return -1;
   }
@@ -119,5 +119,5 @@
    */
 
-  Chain_Extract( ( Chain_Node * ) temp_loc.mt_entry );
+  Chain_Extract( ( Chain_Node * ) fs_root_loc.mt_entry );
 
   /*
@@ -125,7 +125,7 @@
    */
 
-  rtems_filesystem_freenode( &temp_loc.mt_entry->mt_point_node );
-  free( temp_loc.mt_entry );
-  rtems_filesystem_freenode( &temp_loc );
+  rtems_filesystem_freenode( &fs_root_loc.mt_entry->mt_point_node );
+  free( fs_root_loc.mt_entry );
+  rtems_filesystem_freenode( &fs_root_loc );
 
   return 0;
@@ -146,7 +146,7 @@
 
 int file_systems_below_this_mountpoint( 
-  const char                            *mount_path,
-  rtems_filesystem_location_info_t      *temp_loc,
-  rtems_filesystem_mount_table_entry_t  *temp_mt_entry
+  const char                            *path,
+  rtems_filesystem_location_info_t      *fs_root_loc,
+  rtems_filesystem_mount_table_entry_t  *fs_to_unmount
 )
 {
@@ -156,13 +156,21 @@
 
   /*
-   *  Is the mount_path even a valid node name in the existing tree?
+   *  Is the path even a valid node name in the existing tree?
    */
 
-  if ( rtems_filesystem_evaluate_path( mount_path, 0x0, temp_loc, TRUE ) )
+  if ( rtems_filesystem_evaluate_path( path, 0x0, fs_root_loc, TRUE ) )
     return -1;
   
   /*
-   *  Look for the node defined in temp_loc as a mount point in the
-   *  mount table chain.
+   * Verify this is the root node for the file system to be unmounted.
+   */
+
+  *fs_to_unmount = *fs_root_loc->mt_entry;
+  if ( fs_to_unmount->mt_fs_root.node_access != fs_root_loc->node_access )
+    set_errno_and_return_minus_one( EACCES );
+
+  /*
+   * Search the mount table for any mount entries referencing this
+   * mount entry.
    */
 
@@ -170,41 +178,10 @@
         !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
         the_node = the_node->next ) {
-
      the_mount_entry = ( rtems_filesystem_mount_table_entry_t * )the_node;
-     if  (the_mount_entry->mt_point_node.node_access  ==
-          temp_loc->node_access ) {
-        current_fs_mt_entry = the_mount_entry;
-        *temp_loc = current_fs_mt_entry->mt_fs_root;
-        goto after_real_mount_point_found;
-     }
-  }
-  set_errno_and_return_minus_one( EACCES );
-
-
-after_real_mount_point_found:
-
-  for ( the_node = rtems_filesystem_mount_table_control.first;
-        !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
-        the_node = the_node->next ) {
-
-     the_mount_entry = (  rtems_filesystem_mount_table_entry_t * )the_node;
-
-     /*
-      *  Exclude the current file systems mount table entry from the test
-      */
-
-     if ( current_fs_mt_entry != the_mount_entry ) {
-       if ( the_mount_entry->mt_point_node.mt_entry  == current_fs_mt_entry ) {
-
-          /*
-           *  There is at least one fs below the fs on the mount_path.
-           */
+     if (the_mount_entry->mt_point_node.mt_entry  == fs_root_loc->mt_entry ) {
           set_errno_and_return_minus_one( EBUSY );
-       }
      }
   }
 
-  *temp_mt_entry = *current_fs_mt_entry;
-
   return 0;
 }
Index: c/src/lib/libc/mount.c
===================================================================
--- c/src/lib/libc/mount.c	(revision ee6d2050d1523110f09417e12cd1df8e2d4ad639)
+++ c/src/lib/libc/mount.c	(revision 4b0d1ab39bad414e8d5ecfb46f66e75387152458)
@@ -36,9 +36,8 @@
  */
 
-int search_mt_for_mount_point(
-  rtems_filesystem_location_info_t *location_of_mount_point
+int init_fs_mount_table( void );
+static int Is_node_fs_root(
+  rtems_filesystem_location_info_t  *loc
 );
-
-int init_fs_mount_table( void );
 
 
@@ -141,5 +140,5 @@
      */
 
-    if ( search_mt_for_mount_point( &loc ) == FOUND ) {
+    if ( Is_node_fs_root(  &loc ) ){
       errno = EBUSY;
       goto cleanup_and_bail;
@@ -233,19 +232,17 @@
 }
 
-
-/*
- *  search_mt_for_mount_point
+/*
+ *  Is_node_fs_root
  *
  *  This routine will run through the entries that currently exist in the
  *  mount table chain. For each entry in the mount table chain it will
- *  compare the mount tables mt_point_node to the node describing the selected
- *  mount point.. If any of the mount table file system mount point nodes
- *  match the new file system selected mount point node, we are attempting
- *  to mount the new file system onto a node that already has a file system
- *  mounted to it. This is not a permitted operation.
- */
-
-int search_mt_for_mount_point(
-  rtems_filesystem_location_info_t *location_of_mount_point
+ *  compare the mount tables root node to the node describing the selected
+ *  mount point. If any match is found true is returned else false is 
+ *  returned.
+ *
+ */
+
+static int Is_node_fs_root(
+  rtems_filesystem_location_info_t  *loc
 )
 {
@@ -253,14 +250,15 @@
   rtems_filesystem_mount_table_entry_t *the_mount_entry;
 
+  /* 
+   * For each mount table entry 
+   */
+
   for ( the_node = rtems_filesystem_mount_table_control.first;
         !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
         the_node = the_node->next ) {
-
      the_mount_entry = (rtems_filesystem_mount_table_entry_t *) the_node;
-     if ( the_mount_entry->mt_point_node.node_access  == 
-             location_of_mount_point->node_access )
-        return FOUND;
-  }
-  return NOT_FOUND;
+     if ( the_mount_entry->mt_fs_root.node_access  == loc->node_access )
+        return TRUE;
+  }
+  return FALSE;
 }
-
Index: c/src/lib/libc/unmount.c
===================================================================
--- c/src/lib/libc/unmount.c	(revision ee6d2050d1523110f09417e12cd1df8e2d4ad639)
+++ c/src/lib/libc/unmount.c	(revision 4b0d1ab39bad414e8d5ecfb46f66e75387152458)
@@ -42,5 +42,5 @@
 
 int file_systems_below_this_mountpoint( 
-  const char                            *mount_path,
+  const char                            *path,
   rtems_filesystem_location_info_t      *temp_loc,
   rtems_filesystem_mount_table_entry_t  *temp_mt_entry
@@ -51,23 +51,23 @@
  * 
  *  This routine will attempt to unmount the file system that has been
- *  is mounted a mount_path.  If the operation is successful, 0 will
+ *  is mounted a path.  If the operation is successful, 0 will
  *  be returned to the calling routine.  Otherwise, 1 will be returned.
  */
 
 int unmount(
-  const char *mount_path
+  const char *path
 )
 {
   int                                   status;
-  rtems_filesystem_location_info_t      temp_loc;
+  rtems_filesystem_location_info_t      fs_root_loc;
   rtems_filesystem_mount_table_entry_t  temp_mt_entry;
 
   /*
-   *  Are there any file systems below the mount_path specified
+   *  Are there any file systems below the path specified
    */
 
   status = file_systems_below_this_mountpoint( 
-    mount_path, 
-    &temp_loc,
+    path, 
+    &fs_root_loc,
     &temp_mt_entry
   );
@@ -81,6 +81,6 @@
    */
 
-  if ( rtems_filesystem_current.mt_entry == temp_loc.mt_entry ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ( rtems_filesystem_current.mt_entry == fs_root_loc.mt_entry ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     set_errno_and_return_minus_one( EBUSY );
   }
@@ -92,15 +92,15 @@
    */
 
-  if ( rtems_libio_is_open_files_in_fs( temp_loc.mt_entry ) == 1 ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ( rtems_libio_is_open_files_in_fs( fs_root_loc.mt_entry ) == 1 ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     set_errno_and_return_minus_one( EBUSY );
   }
   
   /*
-   * Allow the file system being mounted on to do its cleanup.
+   * Allow the file system being unmounted on to do its cleanup.
    */
 
-  if ((temp_mt_entry.mt_point_node.ops->unmount_h )( temp_loc.mt_entry ) != 0 ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ((temp_mt_entry.mt_point_node.ops->unmount_h )( fs_root_loc.mt_entry ) != 0 ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     return -1;
   }
@@ -110,6 +110,6 @@
    */
 
-  if ((temp_mt_entry.mt_fs_root.ops->fsunmount_me_h )( temp_loc.mt_entry ) != 0){
-    rtems_filesystem_freenode( &temp_loc );
+  if ((temp_mt_entry.mt_fs_root.ops->fsunmount_me_h )( fs_root_loc.mt_entry ) != 0){
+    rtems_filesystem_freenode( &fs_root_loc );
     return -1;
   }
@@ -119,5 +119,5 @@
    */
 
-  Chain_Extract( ( Chain_Node * ) temp_loc.mt_entry );
+  Chain_Extract( ( Chain_Node * ) fs_root_loc.mt_entry );
 
   /*
@@ -125,7 +125,7 @@
    */
 
-  rtems_filesystem_freenode( &temp_loc.mt_entry->mt_point_node );
-  free( temp_loc.mt_entry );
-  rtems_filesystem_freenode( &temp_loc );
+  rtems_filesystem_freenode( &fs_root_loc.mt_entry->mt_point_node );
+  free( fs_root_loc.mt_entry );
+  rtems_filesystem_freenode( &fs_root_loc );
 
   return 0;
@@ -146,7 +146,7 @@
 
 int file_systems_below_this_mountpoint( 
-  const char                            *mount_path,
-  rtems_filesystem_location_info_t      *temp_loc,
-  rtems_filesystem_mount_table_entry_t  *temp_mt_entry
+  const char                            *path,
+  rtems_filesystem_location_info_t      *fs_root_loc,
+  rtems_filesystem_mount_table_entry_t  *fs_to_unmount
 )
 {
@@ -156,13 +156,21 @@
 
   /*
-   *  Is the mount_path even a valid node name in the existing tree?
+   *  Is the path even a valid node name in the existing tree?
    */
 
-  if ( rtems_filesystem_evaluate_path( mount_path, 0x0, temp_loc, TRUE ) )
+  if ( rtems_filesystem_evaluate_path( path, 0x0, fs_root_loc, TRUE ) )
     return -1;
   
   /*
-   *  Look for the node defined in temp_loc as a mount point in the
-   *  mount table chain.
+   * Verify this is the root node for the file system to be unmounted.
+   */
+
+  *fs_to_unmount = *fs_root_loc->mt_entry;
+  if ( fs_to_unmount->mt_fs_root.node_access != fs_root_loc->node_access )
+    set_errno_and_return_minus_one( EACCES );
+
+  /*
+   * Search the mount table for any mount entries referencing this
+   * mount entry.
    */
 
@@ -170,41 +178,10 @@
         !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
         the_node = the_node->next ) {
-
      the_mount_entry = ( rtems_filesystem_mount_table_entry_t * )the_node;
-     if  (the_mount_entry->mt_point_node.node_access  ==
-          temp_loc->node_access ) {
-        current_fs_mt_entry = the_mount_entry;
-        *temp_loc = current_fs_mt_entry->mt_fs_root;
-        goto after_real_mount_point_found;
-     }
-  }
-  set_errno_and_return_minus_one( EACCES );
-
-
-after_real_mount_point_found:
-
-  for ( the_node = rtems_filesystem_mount_table_control.first;
-        !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
-        the_node = the_node->next ) {
-
-     the_mount_entry = (  rtems_filesystem_mount_table_entry_t * )the_node;
-
-     /*
-      *  Exclude the current file systems mount table entry from the test
-      */
-
-     if ( current_fs_mt_entry != the_mount_entry ) {
-       if ( the_mount_entry->mt_point_node.mt_entry  == current_fs_mt_entry ) {
-
-          /*
-           *  There is at least one fs below the fs on the mount_path.
-           */
+     if (the_mount_entry->mt_point_node.mt_entry  == fs_root_loc->mt_entry ) {
           set_errno_and_return_minus_one( EBUSY );
-       }
      }
   }
 
-  *temp_mt_entry = *current_fs_mt_entry;
-
   return 0;
 }
Index: cpukit/libcsupport/src/mount.c
===================================================================
--- cpukit/libcsupport/src/mount.c	(revision ee6d2050d1523110f09417e12cd1df8e2d4ad639)
+++ cpukit/libcsupport/src/mount.c	(revision 4b0d1ab39bad414e8d5ecfb46f66e75387152458)
@@ -36,9 +36,8 @@
  */
 
-int search_mt_for_mount_point(
-  rtems_filesystem_location_info_t *location_of_mount_point
+int init_fs_mount_table( void );
+static int Is_node_fs_root(
+  rtems_filesystem_location_info_t  *loc
 );
-
-int init_fs_mount_table( void );
 
 
@@ -141,5 +140,5 @@
      */
 
-    if ( search_mt_for_mount_point( &loc ) == FOUND ) {
+    if ( Is_node_fs_root(  &loc ) ){
       errno = EBUSY;
       goto cleanup_and_bail;
@@ -233,19 +232,17 @@
 }
 
-
-/*
- *  search_mt_for_mount_point
+/*
+ *  Is_node_fs_root
  *
  *  This routine will run through the entries that currently exist in the
  *  mount table chain. For each entry in the mount table chain it will
- *  compare the mount tables mt_point_node to the node describing the selected
- *  mount point.. If any of the mount table file system mount point nodes
- *  match the new file system selected mount point node, we are attempting
- *  to mount the new file system onto a node that already has a file system
- *  mounted to it. This is not a permitted operation.
- */
-
-int search_mt_for_mount_point(
-  rtems_filesystem_location_info_t *location_of_mount_point
+ *  compare the mount tables root node to the node describing the selected
+ *  mount point. If any match is found true is returned else false is 
+ *  returned.
+ *
+ */
+
+static int Is_node_fs_root(
+  rtems_filesystem_location_info_t  *loc
 )
 {
@@ -253,14 +250,15 @@
   rtems_filesystem_mount_table_entry_t *the_mount_entry;
 
+  /* 
+   * For each mount table entry 
+   */
+
   for ( the_node = rtems_filesystem_mount_table_control.first;
         !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
         the_node = the_node->next ) {
-
      the_mount_entry = (rtems_filesystem_mount_table_entry_t *) the_node;
-     if ( the_mount_entry->mt_point_node.node_access  == 
-             location_of_mount_point->node_access )
-        return FOUND;
-  }
-  return NOT_FOUND;
+     if ( the_mount_entry->mt_fs_root.node_access  == loc->node_access )
+        return TRUE;
+  }
+  return FALSE;
 }
-
Index: cpukit/libcsupport/src/unmount.c
===================================================================
--- cpukit/libcsupport/src/unmount.c	(revision ee6d2050d1523110f09417e12cd1df8e2d4ad639)
+++ cpukit/libcsupport/src/unmount.c	(revision 4b0d1ab39bad414e8d5ecfb46f66e75387152458)
@@ -42,5 +42,5 @@
 
 int file_systems_below_this_mountpoint( 
-  const char                            *mount_path,
+  const char                            *path,
   rtems_filesystem_location_info_t      *temp_loc,
   rtems_filesystem_mount_table_entry_t  *temp_mt_entry
@@ -51,23 +51,23 @@
  * 
  *  This routine will attempt to unmount the file system that has been
- *  is mounted a mount_path.  If the operation is successful, 0 will
+ *  is mounted a path.  If the operation is successful, 0 will
  *  be returned to the calling routine.  Otherwise, 1 will be returned.
  */
 
 int unmount(
-  const char *mount_path
+  const char *path
 )
 {
   int                                   status;
-  rtems_filesystem_location_info_t      temp_loc;
+  rtems_filesystem_location_info_t      fs_root_loc;
   rtems_filesystem_mount_table_entry_t  temp_mt_entry;
 
   /*
-   *  Are there any file systems below the mount_path specified
+   *  Are there any file systems below the path specified
    */
 
   status = file_systems_below_this_mountpoint( 
-    mount_path, 
-    &temp_loc,
+    path, 
+    &fs_root_loc,
     &temp_mt_entry
   );
@@ -81,6 +81,6 @@
    */
 
-  if ( rtems_filesystem_current.mt_entry == temp_loc.mt_entry ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ( rtems_filesystem_current.mt_entry == fs_root_loc.mt_entry ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     set_errno_and_return_minus_one( EBUSY );
   }
@@ -92,15 +92,15 @@
    */
 
-  if ( rtems_libio_is_open_files_in_fs( temp_loc.mt_entry ) == 1 ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ( rtems_libio_is_open_files_in_fs( fs_root_loc.mt_entry ) == 1 ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     set_errno_and_return_minus_one( EBUSY );
   }
   
   /*
-   * Allow the file system being mounted on to do its cleanup.
+   * Allow the file system being unmounted on to do its cleanup.
    */
 
-  if ((temp_mt_entry.mt_point_node.ops->unmount_h )( temp_loc.mt_entry ) != 0 ) {
-    rtems_filesystem_freenode( &temp_loc );
+  if ((temp_mt_entry.mt_point_node.ops->unmount_h )( fs_root_loc.mt_entry ) != 0 ) {
+    rtems_filesystem_freenode( &fs_root_loc );
     return -1;
   }
@@ -110,6 +110,6 @@
    */
 
-  if ((temp_mt_entry.mt_fs_root.ops->fsunmount_me_h )( temp_loc.mt_entry ) != 0){
-    rtems_filesystem_freenode( &temp_loc );
+  if ((temp_mt_entry.mt_fs_root.ops->fsunmount_me_h )( fs_root_loc.mt_entry ) != 0){
+    rtems_filesystem_freenode( &fs_root_loc );
     return -1;
   }
@@ -119,5 +119,5 @@
    */
 
-  Chain_Extract( ( Chain_Node * ) temp_loc.mt_entry );
+  Chain_Extract( ( Chain_Node * ) fs_root_loc.mt_entry );
 
   /*
@@ -125,7 +125,7 @@
    */
 
-  rtems_filesystem_freenode( &temp_loc.mt_entry->mt_point_node );
-  free( temp_loc.mt_entry );
-  rtems_filesystem_freenode( &temp_loc );
+  rtems_filesystem_freenode( &fs_root_loc.mt_entry->mt_point_node );
+  free( fs_root_loc.mt_entry );
+  rtems_filesystem_freenode( &fs_root_loc );
 
   return 0;
@@ -146,7 +146,7 @@
 
 int file_systems_below_this_mountpoint( 
-  const char                            *mount_path,
-  rtems_filesystem_location_info_t      *temp_loc,
-  rtems_filesystem_mount_table_entry_t  *temp_mt_entry
+  const char                            *path,
+  rtems_filesystem_location_info_t      *fs_root_loc,
+  rtems_filesystem_mount_table_entry_t  *fs_to_unmount
 )
 {
@@ -156,13 +156,21 @@
 
   /*
-   *  Is the mount_path even a valid node name in the existing tree?
+   *  Is the path even a valid node name in the existing tree?
    */
 
-  if ( rtems_filesystem_evaluate_path( mount_path, 0x0, temp_loc, TRUE ) )
+  if ( rtems_filesystem_evaluate_path( path, 0x0, fs_root_loc, TRUE ) )
     return -1;
   
   /*
-   *  Look for the node defined in temp_loc as a mount point in the
-   *  mount table chain.
+   * Verify this is the root node for the file system to be unmounted.
+   */
+
+  *fs_to_unmount = *fs_root_loc->mt_entry;
+  if ( fs_to_unmount->mt_fs_root.node_access != fs_root_loc->node_access )
+    set_errno_and_return_minus_one( EACCES );
+
+  /*
+   * Search the mount table for any mount entries referencing this
+   * mount entry.
    */
 
@@ -170,41 +178,10 @@
         !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
         the_node = the_node->next ) {
-
      the_mount_entry = ( rtems_filesystem_mount_table_entry_t * )the_node;
-     if  (the_mount_entry->mt_point_node.node_access  ==
-          temp_loc->node_access ) {
-        current_fs_mt_entry = the_mount_entry;
-        *temp_loc = current_fs_mt_entry->mt_fs_root;
-        goto after_real_mount_point_found;
-     }
-  }
-  set_errno_and_return_minus_one( EACCES );
-
-
-after_real_mount_point_found:
-
-  for ( the_node = rtems_filesystem_mount_table_control.first;
-        !Chain_Is_tail( &rtems_filesystem_mount_table_control, the_node );
-        the_node = the_node->next ) {
-
-     the_mount_entry = (  rtems_filesystem_mount_table_entry_t * )the_node;
-
-     /*
-      *  Exclude the current file systems mount table entry from the test
-      */
-
-     if ( current_fs_mt_entry != the_mount_entry ) {
-       if ( the_mount_entry->mt_point_node.mt_entry  == current_fs_mt_entry ) {
-
-          /*
-           *  There is at least one fs below the fs on the mount_path.
-           */
+     if (the_mount_entry->mt_point_node.mt_entry  == fs_root_loc->mt_entry ) {
           set_errno_and_return_minus_one( EBUSY );
-       }
      }
   }
 
-  *temp_mt_entry = *current_fs_mt_entry;
-
   return 0;
 }
